# Dirac - A Video Codec

Created by the British Broadcasting Corporation.

Public Member Functions | Private Member Functions | Private Attributes | List of all members
dirac::WaveletTransform Class Reference

A class to do wavelet transforms. More...

`#include <wavelet_utils.h>`

Collaboration diagram for dirac::WaveletTransform:
[legend]

## Public Member Functions
| WaveletTransform (int d=4, WltFilter f=DAUB9_7)
| Constructor. More...
virtual | ~WaveletTransform ()
| Destructor. More...
void | Transform (const Direction d, PicArray &pic_data, CoeffArray &coeff_data)
| Transforms the data to and from the wavelet domain. More...

## Private Member Functions
| WaveletTransform (const WaveletTransform &cpy)
| Private, bodyless copy constructor: class should not be copied. More...
WaveletTransform & | operator= (const WaveletTransform &rhs)
| Private, bodyless copy operator=: class should not be assigned. More...

## Private Attributes
int | m_depth
| Depth of the transform. More...
WltFilter | m_filt_sort
| The (vertical and horizontal) wavelet filter set to be used. More...
VHFilter * | m_vhfilter
| A class to do the vertical and horizontal filtering required. More...

## Detailed Description

A class to do forward and backward wavelet transforms by iteratively splitting or merging the lowest frequency band.

## Constructor & Destructor Documentation

## ◆ WaveletTransform() [1/2]

dirac::WaveletTransform::WaveletTransform | ( | int | d = `4`,
|  | WltFilter | f = `DAUB9_7`
| ) |  |

## ◆ ~WaveletTransform()

virtual dirac::WaveletTransform::~WaveletTransform | ( |  | ) |
| virtual

## ◆ WaveletTransform() [2/2]

dirac::WaveletTransform::WaveletTransform | ( | const WaveletTransform & | cpy | ) |
| private

## Member Function Documentation

## ◆ operator=()

WaveletTransform & dirac::WaveletTransform::operator= | ( | const WaveletTransform & | rhs | ) |
| private

## ◆ Transform()

void dirac::WaveletTransform::Transform | ( | const Direction | d,
|  | PicArray & | pic_data,
|  | CoeffArray & | coeff_data
| ) |  |

Transforms the data to and from the wavelet domain.

Parameters

  d | the direction of the transform
  pic_data | the data to be transformed
  coeff_data | array that holds the transform coefficient data

## Member Data Documentation

## ◆ m_depth

int dirac::WaveletTransform::m_depth
| private

## ◆ m_filt_sort

WltFilter dirac::WaveletTransform::m_filt_sort
| private

## ◆ m_vhfilter

VHFilter* dirac::WaveletTransform::m_vhfilter
| private

The documentation for this class was generated from the following file:

- wavelet_utils.h

© 2004 British Broadcasting Corporation. Dirac code licensed under the Mozilla Public License (MPL) Version 1.1.
HTML documentation generated by Dimitri van Heesch's excellent Doxygen tool.